<template>
  <div class="per-center">
    <div class="per-info">
      <a-card title="个人信息">
        <a-avatar :size="100" icon="user"/>
        <p class="name"><span>{{ user_info.user_name }}</span></p>
        <p class="cell"><span>账户ID：</span><span>{{ user_info.user_id }}</span></p>
        <p class="cell">
          <span>手机号：</span>
          <span>{{ user_info.phone }}</span>
          <a-icon v-if="user_info.phone" type="edit" @click="phoneVisible = true"/>
          <a v-else @click="phoneVisible = true">绑定手机号</a>
        </p>
        <p class="cell">
          <span>邮&emsp;箱：</span>
          <span>{{ user_info.mail }}</span>
          <a-icon v-if="user_info.mail" type="edit" @click="emailVisible = true"/>
          <a v-else @click="emailVisible = true">绑定邮箱</a>
        </p>
        <p class="cell">
          <span>密&emsp;码：</span>
          <span>*********</span>
          <a-icon type="edit" @click="passwordVisible = true"/>
        </p>
      </a-card>
    </div>
    <div class="per-edit">
      <a-tabs default-active-key="1" @change="tabChange">
        <a-tab-pane key="1" tab="订阅设置">
          <a-card :bordered="false">
            <a-form-model
                ref="form2"
                :model="formData2"
                :rules="formData2Rules"
            >
              <a-form-model-item label="平台" prop="game_platform">
                <a-checkbox-group v-model="formData2.game_platform">
                  <a-checkbox value="codeforces">codeforces</a-checkbox>
                  <a-checkbox value="atcoder">atcoder</a-checkbox>
                  <a-checkbox value="力扣">力扣</a-checkbox>
                  <a-checkbox value="牛客网">牛客网</a-checkbox>
                  <a-checkbox value="洛谷">洛谷</a-checkbox>
                  <a-checkbox value="自定义">自定义</a-checkbox>
                </a-checkbox-group>
              </a-form-model-item>
              <a-form-model-item label="比赛时长" prop="game_duration">
                <a-radio-group v-model="formData2.game_duration">
                  <a-radio value="1,2,3,4,5">所有</a-radio>
                  <a-radio value="1">小于1小时</a-radio>
                  <a-radio value="2">小于3小时</a-radio>
                  <a-radio value="3">小于8小时</a-radio>
                  <a-radio value="4">小于24小时</a-radio>
                  <a-radio value="5">大于24小时</a-radio>
                </a-radio-group>
              </a-form-model-item>
              <a-form-model-item label="比赛难度" prop="game_level">
                <a-checkbox-group v-model="formData2.game_level">
                  <a-checkbox value="1">简单</a-checkbox>
                  <a-checkbox value="2">中等</a-checkbox>
                  <a-checkbox value="3">困难</a-checkbox>
                </a-checkbox-group>
              </a-form-model-item>
              <a-form-model-item :wrapper-col="{ span: 14, offset: 4 }">
                <a-button type="primary" :disabled="submit2Disable" @click="submit2">保存</a-button>
              </a-form-model-item>
            </a-form-model>
          </a-card>
        </a-tab-pane>
        <a-tab-pane key="2" tab="推荐设置">
          <a-card :bordered="false">
            <a-form-model
                ref="form3"
                :model="formData3"
                :rules="formData3Rules"
            >
              <a-form-model-item label="平台" prop="game_platform">
                <a-checkbox-group v-model="formData3.game_platform">
                  <a-checkbox value="codeforces">codeforces</a-checkbox>
                  <a-checkbox value="atcoder">atcoder</a-checkbox>
                  <a-checkbox value="力扣">力扣</a-checkbox>
                  <a-checkbox value="牛客网">牛客网</a-checkbox>
                  <a-checkbox value="洛谷">洛谷</a-checkbox>
                  <a-checkbox value="自定义">自定义</a-checkbox>
                </a-checkbox-group>
              </a-form-model-item>
              <a-form-model-item label="比赛时长" prop="game_duration">
                <a-radio-group v-model="formData3.game_duration">
                  <a-radio value="1,2,3,4,5">所有</a-radio>
                  <a-radio value="1">小于1小时</a-radio>
                  <a-radio value="2">小于3小时</a-radio>
                  <a-radio value="3">小于8小时</a-radio>
                  <a-radio value="4">小于24小时</a-radio>
                  <a-radio value="5">大于24小时</a-radio>
                </a-radio-group>
              </a-form-model-item>
              <a-form-model-item label="比赛难度" prop="game_level">
                <a-checkbox-group v-model="formData3.game_level">
                  <a-checkbox value="1">简单</a-checkbox>
                  <a-checkbox value="2">中等</a-checkbox>
                  <a-checkbox value="3">困难</a-checkbox>
                </a-checkbox-group>
              </a-form-model-item>
              <a-form-model-item :wrapper-col="{ span: 14, offset: 4 }">
                <a-button type="primary" :disabled="submit3Disable" @click="submit3">保存</a-button>
              </a-form-model-item>
            </a-form-model>
          </a-card>
        </a-tab-pane>
        <a-tab-pane key="3" tab="推送设置">
          <a-card :bordered="false">
            <a-form-model
                ref="form4"
                :model="formData4"
                :rules="formData4Rules"
            >
              <a-form-model-item label="推送时间" prop="push_time">
                <a-checkbox-group v-model="formData4.push_time">
                  <a-checkbox value="1">开赛前3天</a-checkbox>
                  <a-checkbox value="2">开赛前2天</a-checkbox>
                  <a-checkbox value="3">开赛前1天</a-checkbox>
                  <a-checkbox value="4">开赛前1小时</a-checkbox>
                  <a-checkbox value="5">开赛前半小时</a-checkbox>
                </a-checkbox-group>
              </a-form-model-item>
              <a-form-model-item label="推送方式" prop="push_method">
                <a-checkbox-group v-model="formData4.push_method">
                  <a-checkbox value="site">站内推送</a-checkbox>
                  <a-checkbox value="mail">邮箱推送</a-checkbox>
                </a-checkbox-group>
              </a-form-model-item>
              <a-form-model-item :wrapper-col="{ span: 14, offset: 7 }">
                <a-button type="primary" :disabled="submit4Disable" @click="submit4">保存</a-button>
              </a-form-model-item>
            </a-form-model>
          </a-card>
        </a-tab-pane>
        <a-tab-pane key="5" tab="预约列表">
          <a-card :bordered="false">
            <a-table :data-source="reserveList" rowKey="game_id">
              <a-table-column key="game_name" title="比赛名称" data-index="game_name"/>
              <a-table-column key="website" title="比赛链接" data-index="website" width="200px">
                <template slot-scope="website">
                  <a :href="website" target="_blank">{{website}}</a>
                </template>
              </a-table-column>
              <a-table-column key="game_start_time" title="开始时间" data-index="game_start_time" width="110px"/>
              <a-table-column key="game_end_time" title="结束时间" data-index="game_end_time" width="110px"/>
              <a-table-column key="level" title="难度" data-index="level" width="60px">
                <template slot-scope="level">
                  <span>{{level === 1 ? '简单' : level === 2 ? '中等' : level === 3 ? '困难' : '-'}}</span>
                </template>
              </a-table-column>
              <a-table-column key="platform" title="平台" data-index="platform" width="110px"/>
            </a-table>
          </a-card>
        </a-tab-pane>
        <a-tab-pane key="6" tab="订阅列表">
          <a-card :bordered="false">
            <a-table :data-source="subscribeList" rowKey="game_id">
              <a-table-column key="game_name" title="比赛名称" data-index="game_name"/>
              <a-table-column key="website" title="比赛链接" data-index="website" width="200px">
                <template slot-scope="website">
                  <a :href="website" target="_blank">{{website}}</a>
                </template>
              </a-table-column>
              <a-table-column key="game_start_time" title="开始时间" data-index="game_start_time" width="110px"/>
              <a-table-column key="game_end_time" title="结束时间" data-index="game_end_time" width="110px"/>
              <a-table-column key="level" title="难度" data-index="level" width="60px">
                <template slot-scope="level">
                  <span>{{level === 1 ? '简单' : level === 2 ? '中等' : level === 3 ? '困难' : '-'}}</span>
                </template>
              </a-table-column>
              <a-table-column key="platform" title="平台" data-index="platform" width="110px"/>
            </a-table>
          </a-card>
        </a-tab-pane>
      </a-tabs>
    </div>
    <a-modal v-model="phoneVisible"
             :title="user_info.phone ? '绑定手机号' : '修改绑定手机号'"
             destroyOnClose
             :confirmLoading="saveLoading"
             :afterClose="() => $refs.bindPhone.resetFields()"
             @ok="handlePhone">
      <a-form-model
          ref="bindPhone"
          :model="formPhone"
          :rules="formPhoneRules"
      >
        <a-form-model-item prop="phone">
          <a-input v-model="formPhone.phone" allowClear size="large" placeholder="请输入手机号"/>
        </a-form-model-item>
      </a-form-model>
    </a-modal>
    <a-modal v-model="emailVisible"
             :title="user_info.phone ? '绑定邮箱' : '修改绑定邮箱'"
             destroyOnClose
             :confirmLoading="saveLoading"
             :afterClose="() => $refs.bindEmail.resetFields()"
             @ok="handleEmail">
      <a-form-model
          ref="bindEmail"
          :model="formEmail"
          :rules="formEmailRules"
      >
        <a-form-model-item prop="email">
          <a-input v-model="formEmail.email" allowClear size="large" placeholder="请输入邮箱地址"/>
        </a-form-model-item>
      </a-form-model>
    </a-modal>
    <a-modal v-model="passwordVisible"
             title="修改登录密码"
             destroyOnClose
             :confirmLoading="saveLoading"
             :afterClose="() => $refs.editPassword.resetFields()"
             @ok="handlePassword">
      <a-form-model
          ref="editPassword"
          :model="formPassword"
          :rules="formPasswordRules"
      >
        <a-form-model-item prop="password">
          <a-input-password v-model="formPassword.password" allowClear visibilityToggle size="large" type="password" placeholder="新密码（8-16位字母和数字）" />
        </a-form-model-item>
        <a-form-model-item prop="confirmPassword">
          <a-input-password v-model="formPassword.confirmPassword" allowClear visibilityToggle size="large" type="password" placeholder="请再次输入新密码" />
        </a-form-model-item>
      </a-form-model>
    </a-modal>
  </div>
</template>

<script>
import {mapState} from 'vuex'

export default {
  data() {
    let validatePhone = (rule, value, callback) => {
      if (!value) {
        return callback(new Error('手机号为必填项'));
      } else if (!/^1[3456789]\d{9}$/.test(this.formPhone.phone)) {
        return callback(new Error('手机号格式错误'));
      } else {
        this.$axios.post('register/phone/check',
            {
              phonenum: this.formPhone.phone
            }).then(res => {
          if (res.code == 0) {
            callback()
          } if (res.code == 501) {
            return callback(new Error(res.info));
          } else {
            return callback(new Error('手机号校验失败'));
          }
        }).catch(() => {
          return callback(new Error('手机号校验失败'));
        })
      }
    }

    let validateEmail = (rule, value, callback) => {
      if (!value) {
        return callback(new Error('邮箱为必填项'));
      } else if (this.formEmail.email.search(/^\w+((-\w+)|(\.\w+))*@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+$/) == -1) {
        return callback(new Error('邮箱格式错误'));
      } else {
        this.$axios.post('register/email/check',
            {
              email: this.formEmail.email
            }).then(res => {
          if (res.code == 0) {
            callback()
          } if (res.code == 501) {
            return callback(new Error(res.info));
          } else {
            return callback(new Error('邮箱校验失败'));
          }
        }).catch(() => {
          return callback(new Error('邮箱校验失败'));
        })
      }
    }

    let validatePassword = (rule, value, callback) => {
      let reg = /^(?=.*\d)(?=.*[a-zA-Z])[\da-zA-Z]{8,16}$/g
      if (!value) {
        return callback(new Error('密码为必填项'));
      } else if (!reg.test(value)) {
        return callback(new Error('密码必须为8-16位字母和数字的组合'));
      } else {
        if (this.formPassword.confirmPassword != '') {
          this.$refs.editPassword.validateField('confirmPassword');
        }
        callback();
      }
    }

    let validateConfirmPassword = (rule, value, callback) => {
      if (!value) {
        return callback(new Error('密码为必填项'));
      } else if (value != this.formPassword.password) {
        return callback(new Error('两次密码不一致'));
      } else {
        callback()
      }
    }
    return {
      token: "null",
      labelCol: {span: 4},
      formPhone: {
        phone: ''
      },
      formPhoneRules: {
        phone: [{validator: validatePhone, trigger: 'blur'}]
      },
      formEmail: {
        email: ''
      },
      formEmailRules: {
        email: [{validator: validateEmail, trigger: 'blur'}]
      },
      formPassword: {
        password: '',
        confirmPassword: ''
      },
      formPasswordRules: {
        password: [{validator: validatePassword, trigger: 'blur'}],
        confirmPassword: [{validator: validateConfirmPassword, trigger: 'blur'}],
      },
      formData2: {
        game_platform: [],
        game_duration: "",
        game_level: []
      },
      formData2Rules: {
        game_platform: [{required: true, message: '请选择平台', trigger: 'change'}],
        game_duration: [{required: true, message: '请选择比赛时长', trigger: 'change'}],
        game_level: [{required: true, message: '请选择比赛难度', trigger: 'change'}]
      },
      formData3: {
        game_platform: [],
        game_duration: "",
        game_level: []
      },
      formData3Rules: {
        game_platform: [{required: true, message: '请选择平台', trigger: 'change'}],
        game_duration: [{required: true, message: '请选择比赛时长', trigger: 'change'}],
        game_level: [{required: true, message: '请选择比赛难度', trigger: 'change'}]
      },
      formData4: {
        push_time: [],
        push_method: []
      },
      formData4Rules: {
        push_time: [{required: true, message: '请选择推送时间', trigger: 'change'}],
        push_method: [{required: true, message: '请选择推送方式', trigger: 'change'}]
      },
      loading: false,
      buttonLoading: false,
      gameList: [
        {
          game_name: "【LGR-109】洛谷 5 月月赛 II & Windy Round 6",
          platform: "洛谷",
          website: "https://www.luogu.com.cn/contest/68326"
        }, {
          game_name: "牛客小白月赛49",
          platform: "牛客网",
          website: "https://ac.nowcoder.com/acm/contest/11226"
        }, {
          game_name: "第 78 场双周赛",
          platform: "LeetCode力扣",
          website: "https://leetcode-cn.com/contest/biweekly-contest-78"
        }, {
          game_name: "Panasonic Programming Contest 2022(AtCoder Beginner Contest 251)",
          platform: "AtCoder",
          website: "https://atcoder.jp/contests/abc251"
        }, {
          game_name: "Educational Codeforces Round 128 (Rated for Div. 2)",
          platform: "CodeForces",
          website: "https://codeforces.com/contests/1680"
        },],
      reserveList: [],
      subscribeList: [],
      phoneVisible: false,
      emailVisible: false,
      passwordVisible: false,
      saveLoading: false
    };
  },

  computed: {
    ...mapState("user", ['user_info']),

    submit2Disable() {
      return this.formData2.game_platform.length === 0 || this.formData2.game_level === '' || this.formData2.game_level.length === 0
    },

    submit3Disable() {
      return this.formData3.game_platform.length === 0 || this.formData3.game_level === '' || this.formData3.game_level.length === 0
    },

    submit4Disable() {
      return this.formData4.push_method.length === 0 || this.formData4.push_time.length === 0
    }
  },
  created: function () {
    this.getSubjectInfo()
    this.getRecommendInfo()
    this.getPushInfo()
    this.getReserveList()
  },
  methods: {
    getSubjectInfo() {
      this.$axios.get('subscribe/query').then((res) => {
        if (res.code == undefined) {
          this.formData2.game_platform = res.game_platform.split(',')
          this.formData2.game_duration = res.game_duration
          this.formData2.game_level = res.game_level.split(',')
        }
      })
    },

    getRecommendInfo() {
      this.$axios.get('recommend/query').then((res) => {
        if (res.code == undefined) {
          this.formData3.game_platform = res.game_platform.split(',')
          this.formData3.game_duration = res.game_duration
          this.formData3.game_level = res.game_level.split(',')
        }
      })
    },

    getPushInfo() {
      this.$axios.get('push/query').then((res) => {
        if (res.code == undefined) {
          this.formData4.push_time = res.push_time.split(',')
          this.formData4.push_method = res.push_method.split(',')
        }
      })
    },

    getReserveList() {
      this.$axios.get('reserve/game').then(res => {
        if (res.code === undefined) {
          this.reserveList = res
        }
      })
    },

    getSubscribeList() {
      this.$axios.get('subscribe/game').then(res => {
        if (res.code === undefined) {
          this.subscribeList = res
        }
      })
    },

    tabChange(activeKey) {
      if (activeKey === '6') {
        this.getSubscribeList()
      }
    },

    submit2() {
      this.$refs.form2.validate(async valid => {
        if (valid) {
          let params = {}
          params.game_platform = this.formData2.game_platform.join()
          params.game_duration = this.formData2.game_duration
          params.game_level = this.formData2.game_level.join()
          this.buttonLoading = true
          await this.$axios.post('subscribe/set', params).then(res => {
            if (res.code == 0) {
              this.$message.success('设置成功')
            } else {
              this.$message.error('设置成功')
            }
          }).catch(() => {
            this.$message.error('设置成功')
          })
          this.buttonLoading = false
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },
    submit3() {
      this.$refs.form3.validate(async valid => {
        if (valid) {
          let params = {}
          params.game_platform = this.formData3.game_platform.join()
          params.game_duration = this.formData3.game_duration
          params.game_level = this.formData3.game_level.join()
          this.buttonLoading = true
          await this.$axios.post('recommend/set', params).then(res => {
            if (res.code == 0) {
              this.$message.success('设置成功')
            } else {
              this.$message.error('设置成功')
            }
          }).catch(() => {
            this.$message.error('设置成功')
          })
          this.buttonLoading = false
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },

    submit4() {
      this.$refs.form4.validate(async valid => {
        if (valid) {
          let params = {}
          params.push_time = this.formData4.push_time.join()
          params.push_method = this.formData4.push_method.join()
          this.buttonLoading = true
          await this.$axios.post('push/set', params).then(res => {
            if (res.code == 0) {
              this.$message.success('设置成功')
            } else {
              this.$message.error('设置成功')
            }
          }).catch(() => {
            this.$message.error('设置失败')
          })
          this.buttonLoading = false
        }
      });
    },

    handlePhone() {
      this.$refs.bindPhone.validate(async valid => {
        if (valid) {
          this.saveLoading = true
          await this.$axios.post('/alter', {
            phone: this.formPhone.phone,
            user_name_old: this.user_info.user_name
          }).then(res => {
            if (res.code == 0) {
              this.phoneVisible = false
              if (this.user_info.phone) {
                this.$notification.success({message: '绑定成功'})
              } else {
                this.$notification.success({message: '修改成功'})
              }
              this.$store.state.user.user_info.phone = this.formPhone.phone
            } else {
              if (this.user_info.phone) {
                this.$notification.success({message: '绑定失败'})
              } else {
                this.$notification.success({message: '修改失败'})
              }
            }
          }).catch(() => {
            if (this.user_info.phone) {
              this.$notification.success({message: '绑定失败'})
            } else {
              this.$notification.success({message: '修改失败'})
            }
          })
          this.saveLoading = false
        }
      })
    },

    handleEmail() {
      this.$refs.bindPhone.validate(async valid => {
        if (valid) {
          this.saveLoading = true
          await this.$axios.post('/alter', {
            mail: this.formEmail.email,
            user_name_old: this.user_info.user_name
          }).then(res => {
            if (res.code == 0) {
              this.emailVisible = false
              if (this.user_info.mail) {
                this.$notification.success({message: '绑定成功'})
              } else {
                this.$notification.success({message: '修改成功'})
              }
              this.$store.state.user.user_info.mail = this.formEmail.email
            } else {
              if (this.user_info.mail) {
                this.$notification.success({message: '绑定失败'})
              } else {
                this.$notification.success({message: '修改失败'})
              }
            }
          }).catch(() => {
            if (this.user_info.mail) {
              this.$notification.success({message: '绑定失败'})
            } else {
              this.$notification.success({message: '修改失败'})
            }
          })
          this.saveLoading = false
        }
      })
    },

    handlePassword() {
      this.$refs.editPassword.validate( async valid => {
        if (valid) {
          this.saveLoading = true
          await this.$axios.post('register/reset_password', {
            password: this.formPassword.password
          }).then(res => {
            if (res.code == 0) {
              this.passwordVisible = false
              this.$notification.success({
                message: '密码重置成功'
              })
            } else {
              this.$notification.error({
                message: '密码重置失败'
              })
            }
          }).catch(() => {
            this.$notification.error({
              message: '密码重置失败'
            })
          })
          this.saveLoading = false
        }
      })
    }
  },
};
</script>
<style lang="less" scoped>
.per-center {
  width: 1200px;
  margin: 0 auto;
  padding: 50px 0;
  display: flex;

  .per-info {
    width: 300px;

    /deep/ .ant-card-head {
      font-weight: bold;
      text-align: center;
    }

    /deep/ .ant-card-body {
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
      padding: 24px 16px;

      .ant-avatar {
        margin-bottom: 20px;
      }
    }

    .name {
      span:first-child {
        font-size: 30px;
        font-weight: bold;
      }
    }

    .cell {
      width: 100%;
      display: flex;
      align-items: center;

      span:first-child {
        width: 100px;
        text-align: right;
      }

      /deep/ .anticon {
        margin-left: 20px;
        cursor: pointer;
      }
    }
  }

  .per-edit {
    flex: 1;
    padding-left: 100px;
    box-sizing: border-box;
    overflow: auto;
    /deep/ .ant-card-body {
      padding-left: 0;
      padding-right: 0;
    }
  }
}
</style>